#line 1 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/CoreTimer.c"
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
#line 27 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
typedef struct {
 unsigned char ss;
 unsigned char mn;
 unsigned char hh;
 unsigned char md;
 unsigned char wd;
 unsigned char mo;
 unsigned int yy;
} TimeStruct ;
#line 40 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
extern long Time_jd1970 ;
#line 45 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
long Time_dateToEpoch(TimeStruct *ts);
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/coretimer.h"
#line 13 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/coretimer.h"
void InitCoreTimer(void);
void TimerCheck();
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/uart1.h"
#line 29 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/uart1.h"
typedef void (*tPointerFcn)(void);
typedef char *pnt;


 typedef struct rx_q_struct
 {
 int RxIn;
 int RxOut;
 char RxQueue[ 64 ];
 } rx_q_struct;


typedef struct tx_q_struct
{
 int TxIn;
 int TxOut;
 pnt TxQueue[ 32 ];
} tx_q_struct;




void UART1_SetBaud(void);
void UART1_StartRx(void);
void UART1_StartTx(void);

void InitUART1(void);
void UART1_TxQueueInit(void);
void UART1_RxQueueInit(void);

void UART1_SendMsg(char *s);
void UART1_CheckQueue(void);
void UART1_PutQueue(char *msg);
char UART1_GetChar(char *rxbyte);


void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void PrintChar(char Ch);
#line 15 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/CoreTimer.c"
unsigned short int TimerFlag = 0;
unsigned long int msec = 0;
long Epoch;
TimeStruct ts1;



void CoreTimer_Interrupt() iv IVT_CORE_TIMER ilevel 7 ics ICS_SRS {
 unsigned long int RegValue;

 msec++;
 if (msec>999) {
 msec = 0;
 Epoch += 1;
 TimerFlag = 1;


 }

 RegValue = CP0_GET(CP0_COMPARE);
 RegValue += 40000;
 CP0_SET(CP0_COMPARE, RegValue);
 CTIF_bit = 0;
}


void InitCoreTimer(void) {
 ts1.ss = 0;
 ts1.mn = 0;
 ts1.hh = 0;
 ts1.md = 28;
 ts1.wd = 3;
 ts1.mo = 6;
 ts1.yy = 2012;

 Epoch = Time_dateToEpoch(&ts1);

 CP0_SET(CP0_COUNT, 0);
 CP0_SET(CP0_COMPARE, 40000);

 CTIP0_bit = 1;
 CTIP1_bit = 1;
 CTIP2_bit = 1;

 CTIS0_bit = 1;
 CTIS1_bit = 1;

 CTIF_bit = 0;
 CTIE_bit = 1;
}


void TimerCheck() {
 if (TimerFlag == 1) {
 TimerFlag = 0;
 Time_epochToDate(Epoch, &ts1);




 }
}
