#line 1 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MMC_Driver.c"
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/common.h"
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
#line 27 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
typedef struct {
 unsigned char ss;
 unsigned char mn;
 unsigned char hh;
 unsigned char md;
 unsigned char wd;
 unsigned char mo;
 unsigned int yy;
} TimeStruct ;
#line 40 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
extern long Time_jd1970 ;
#line 45 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
long Time_dateToEpoch(TimeStruct *ts);
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/mmc_driver.h"
#line 14 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/mmc_driver.h"
void InitMMC();

char CreateFile(char *FileName);
char WriteFile(char *buf);
char CloseFile(void);
short OpenFile(char *filename);
int ReadFile(char *buf);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/uart1.h"
#line 29 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/uart1.h"
typedef void (*tPointerFcn)(void);
typedef char *pnt;


 typedef struct rx_q_struct
 {
 int RxIn;
 int RxOut;
 char RxQueue[ 64 ];
 } rx_q_struct;


typedef struct tx_q_struct
{
 int TxIn;
 int TxOut;
 pnt TxQueue[ 32 ];
} tx_q_struct;




void UART1_SetBaud(void);
void UART1_StartRx(void);
void UART1_StartTx(void);

void InitUART1(void);
void UART1_TxQueueInit(void);
void UART1_RxQueueInit(void);

void UART1_SendMsg(char *s);
void UART1_CheckQueue(void);
void UART1_PutQueue(char *msg);
char UART1_GetChar(char *rxbyte);


void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void PrintChar(char Ch);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
#line 40 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned char status;
 unsigned char type;
 unsigned long offset;

} PART;
#line 51 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned int bytesPerSect;
 unsigned int sectPerCluster;
 unsigned int reserved;
 unsigned char FATcopies;
 unsigned int maxRootEntries;
 unsigned int sectPerFAT;
 unsigned long FATstart;
 unsigned long rootDir;
 unsigned long dataArea;
} BOOT_STRUCT;
#line 67 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned char nameExt[11];
 unsigned char attrib;
 unsigned char reserved;
 unsigned char fineTime;
 unsigned char ctime[2];
 unsigned char cdate[2];
 unsigned char adate[2];
 unsigned char extAttrib[2];
 unsigned char mtime[2];
 unsigned char mdate[2];
 unsigned char first[2];
 unsigned char size[4];
} FAT16_DIRENT;
#line 88 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned char name[13];
 unsigned char attrib;
 unsigned char ctime[6];
 unsigned char mtime[6];
 unsigned long size;
 unsigned int first;
 unsigned long sect;
 unsigned int entry;
} DIR;
#line 103 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned long dirSectNum;
 unsigned int dirOffSect;
 unsigned int openFirst;
 unsigned long openCursor;
 unsigned int openCluster;
 unsigned long openSect;
 unsigned int openSectIdx;
 unsigned int openIdx;
 unsigned long openLength;
 unsigned int openMode;
} FILE;
#line 120 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 union
 {
 unsigned long ______;
 char fSect[ 512 ];
 };
 char fReadNeedsUpdate;

} SECTOR;


extern const unsigned char f16_boot_template[];
extern const unsigned char MAX_FILES;
extern const unsigned char CRLF[];
extern FILE f16_fileDesc[];
extern SECTOR f16_sector;
#line 141 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
char Mmc_Fat_Init(void);
char Mmc_Fat_Dir(void (*printfcn)(char ch));
char Mmc_Fat_MakeDir(char *name, char attrib);
char Mmc_Fat_RemoveDir(char *name);
char Mmc_Fat_Delete(void);
char Mmc_Fat_ChangeDir(char *name);
char Mmc_Fat_RenameDir(char *old, char *new);
char Mmc_Fat_Exists(char *name);
char Mmc_Fat_ExistsRecursive(char* name);
char Mmc_Fat_Rename(char *newname);
char Mmc_Fat_Assign(char *name, char attrib);
void Mmc_Fat_Append(void);
void Mmc_Fat_Read(char *fdata);
void Mmc_Fat_Write(char *fdata, unsigned int len);
void Mmc_Fat_Rewrite(void);
unsigned long Mmc_Fat_Tell(void);
unsigned long Mmc_Fat_Seek(unsigned long pos);
void Mmc_Fat_Reset(unsigned long *size);
unsigned long Mmc_Fat_Get_File_Size(void);
char Mmc_Fat_QuickFormat(char* volume_label);
unsigned long Mmc_Fat_Get_Swap_File(unsigned long nSect, char* name, char file_attr);

void Mmc_Fat_Set_File_Date(unsigned int year, unsigned short month, unsigned short day, unsigned short hours, unsigned short mins, unsigned short seconds);
void Mmc_Fat_Get_File_Date(unsigned int *year, unsigned short *month, unsigned short *day, unsigned short *hours, unsigned short *mins);
void Mmc_Fat_Get_File_Date_Modified(unsigned int *year, unsigned short *month, unsigned short *day, unsigned short *hours, unsigned short *mins);
#line 14 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MMC_Driver.c"
sbit Mmc_Chip_Select at LATA9_bit;
sbit Mmc_Chip_Select_Direction at TRISA9_bit;


char FileName[32];
char Buffer[512];
char LineBuf[128];
char OutBuf[128];
int BytePtr;

char OpenDate[16];
char OpenTime[16];
char CloseTime[16];

char CardOK =  0 ;




int FileSM = 0;




extern TimeStruct ts1;
extern UART_Busy;
#line 51 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MMC_Driver.c"
void InitMMC() {
 unsigned int CardStatus;


 SPI1_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 64, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);
 Delay_ms(10);


 CardStatus = Mmc_Fat_Init();

 if (CardStatus > 0) {
 CardOK =  0 ;
  UART1_PutQueue("SD card missing\r\n") ;
 } else {

 SPI1_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 8, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);
 CardOK =  1 ;
  UART1_PutQueue("SPI set to high speed\r\n") ;
 }
  UART1_PutQueue("SPI initialized\r\n") ;
}
#line 79 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MMC_Driver.c"
char CreateFile(char *filename) {
 int Month, Day, Hour, Minute, Second;
 char TDString[32];


 if (CardOK ==  1 ) {

 Month = ts1.mo;
 Day = ts1.md;
 Hour = ts1.hh;
 Minute = ts1.mn;
 Second = ts1.ss;

 sprintf(TDString,"%04d/%02d/%02d %02d:%02d:%02d",ts1.yy,Month,Day,Hour,Minute,Second);

 if (Mmc_Fat_Exists(filename)) {

 Mmc_Fat_Assign(filename, 0);
 Mmc_Fat_Append();
 return 1;

 } else {

 Mmc_Fat_Assign(filename, 0xA0);
 Mmc_Fat_Set_File_Date(ts1.yy,ts1.mo,ts1.md,ts1.hh,ts1.mn,ts1.ss);
 Mmc_Fat_Rewrite();
 return 2;
 }

 } else {
 return 0;
 }
}
#line 119 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MMC_Driver.c"
char WriteFile(char *buf) {
 if (CardOK ==  1 ) {
 Mmc_Fat_Write(buf,strlen(buf));
 return 1;
 } else {
 return 0;
 }
}
#line 134 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MMC_Driver.c"
char CloseFile(void) {
 if (Mmc_Fat_Close() == 0) {
 return 1;
 } else {
 return 0;
 }
}
#line 147 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MMC_Driver.c"
short OpenFile(char *filename) {
 if (CardOK ==  1 ) {
 Mmc_Fat_Open(filename,  0x01 , 0x01);
 return 1;
 } else {
 return 0;
 }
}
#line 164 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MMC_Driver.c"
int ReadFile(char *buf) {
 int status;
 int Count;
 char Ch;

 status = Mmc_Fat_EOF();

 if (status == 0) {
 memset(buf,0,128);
 Count = 0;
 Ch = 0;

 while ((Ch != '\n') && (Count < 127)) {
 Mmc_Fat_Read(&Ch);
 buf[Count++] = Ch;
 }
 }
 return (status);
}
