#line 1 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/common.h"
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/uart1.h"
#line 29 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/uart1.h"
typedef void (*tPointerFcn)(void);
typedef char *pnt;


 typedef struct rx_q_struct
 {
 int RxIn;
 int RxOut;
 char RxQueue[ 64 ];
 } rx_q_struct;


typedef struct tx_q_struct
{
 int TxIn;
 int TxOut;
 pnt TxQueue[ 32 ];
} tx_q_struct;




void UART1_SetBaud(void);
void UART1_StartRx(void);
void UART1_StartTx(void);

void InitUART1(void);
void UART1_TxQueueInit(void);
void UART1_RxQueueInit(void);

void UART1_SendMsg(char *s);
void UART1_CheckQueue(void);
void UART1_PutQueue(char *msg);
char UART1_GetChar(char *rxbyte);


void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void PrintChar(char Ch);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/buffers.h"
#line 13 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/buffers.h"
char* GetBuffer(void);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
#line 27 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
typedef struct {
 unsigned char ss;
 unsigned char mn;
 unsigned char hh;
 unsigned char md;
 unsigned char wd;
 unsigned char mo;
 unsigned int yy;
} TimeStruct ;
#line 40 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
extern long Time_jd1970 ;
#line 45 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__time.h"
long Time_dateToEpoch(TimeStruct *ts);
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/mmc_driver.h"
#line 14 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/mmc_driver.h"
void InitMMC();

char CreateFile(char *FileName);
char WriteFile(char *buf);
char CloseFile(void);
short OpenFile(char *filename);
int ReadFile(char *buf);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
#line 40 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned char status;
 unsigned char type;
 unsigned long offset;

} PART;
#line 51 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned int bytesPerSect;
 unsigned int sectPerCluster;
 unsigned int reserved;
 unsigned char FATcopies;
 unsigned int maxRootEntries;
 unsigned int sectPerFAT;
 unsigned long FATstart;
 unsigned long rootDir;
 unsigned long dataArea;
} BOOT_STRUCT;
#line 67 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned char nameExt[11];
 unsigned char attrib;
 unsigned char reserved;
 unsigned char fineTime;
 unsigned char ctime[2];
 unsigned char cdate[2];
 unsigned char adate[2];
 unsigned char extAttrib[2];
 unsigned char mtime[2];
 unsigned char mdate[2];
 unsigned char first[2];
 unsigned char size[4];
} FAT16_DIRENT;
#line 88 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned char name[13];
 unsigned char attrib;
 unsigned char ctime[6];
 unsigned char mtime[6];
 unsigned long size;
 unsigned int first;
 unsigned long sect;
 unsigned int entry;
} DIR;
#line 103 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 unsigned long dirSectNum;
 unsigned int dirOffSect;
 unsigned int openFirst;
 unsigned long openCursor;
 unsigned int openCluster;
 unsigned long openSect;
 unsigned int openSectIdx;
 unsigned int openIdx;
 unsigned long openLength;
 unsigned int openMode;
} FILE;
#line 120 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
typedef struct
{
 union
 {
 unsigned long ______;
 char fSect[ 512 ];
 };
 char fReadNeedsUpdate;

} SECTOR;


extern const unsigned char f16_boot_template[];
extern const unsigned char MAX_FILES;
extern const unsigned char CRLF[];
extern FILE f16_fileDesc[];
extern SECTOR f16_sector;
#line 141 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/__lib_mmcfat16.h"
char Mmc_Fat_Init(void);
char Mmc_Fat_Dir(void (*printfcn)(char ch));
char Mmc_Fat_MakeDir(char *name, char attrib);
char Mmc_Fat_RemoveDir(char *name);
char Mmc_Fat_Delete(void);
char Mmc_Fat_ChangeDir(char *name);
char Mmc_Fat_RenameDir(char *old, char *new);
char Mmc_Fat_Exists(char *name);
char Mmc_Fat_ExistsRecursive(char* name);
char Mmc_Fat_Rename(char *newname);
char Mmc_Fat_Assign(char *name, char attrib);
void Mmc_Fat_Append(void);
void Mmc_Fat_Read(char *fdata);
void Mmc_Fat_Write(char *fdata, unsigned int len);
void Mmc_Fat_Rewrite(void);
unsigned long Mmc_Fat_Tell(void);
unsigned long Mmc_Fat_Seek(unsigned long pos);
void Mmc_Fat_Reset(unsigned long *size);
unsigned long Mmc_Fat_Get_File_Size(void);
char Mmc_Fat_QuickFormat(char* volume_label);
unsigned long Mmc_Fat_Get_Swap_File(unsigned long nSect, char* name, char file_attr);

void Mmc_Fat_Set_File_Date(unsigned int year, unsigned short month, unsigned short day, unsigned short hours, unsigned short mins, unsigned short seconds);
void Mmc_Fat_Get_File_Date(unsigned int *year, unsigned short *month, unsigned short *day, unsigned short *hours, unsigned short *mins);
void Mmc_Fat_Get_File_Date_Modified(unsigned int *year, unsigned short *month, unsigned short *day, unsigned short *hours, unsigned short *mins);
#line 16 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
char RcvBuf[ 64 ];
char RcvBufPtr;

char *XmtBuf;
char XmtBufPtr;
char UART_Busy =  0 ;


rx_q_struct RxQ;
tx_q_struct TxQ;


tPointerFcn UART1_RxFuncPtr = UART1_Rx1;






char FileDataBfr[512];


int Counter1;


char Ch;




extern char LineBuf[128];
#line 52 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Interrupt() iv IVT_UART_1 ilevel 7 ics ICS_AUTO {
 char R_data;
 char T_data;

 if (URXDA_bit) {
 R_data = U1RXREG;

 RxQ.RxQueue[RxQ.RxIn++] = R_data;
 if (RxQ.RxIn > ( 64 -1))
 RxQ.RxIn = 0;
 U1RXIF_bit = 0;

 } else {
 T_data = XmtBuf[XmtBufPtr++];
 if (T_data ==  0x00 ) {
 U1TXIE_bit = 0;
 } else {
 U1TXREG = T_data;
 U1TXIF_bit = 0;
 }
 }
}
#line 77 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_SetBaud(void) {

 U1BRG = 520;
}
#line 84 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_StartRx(void) {
 ON__U1MODE_bit = 1;
 URXEN_bit = 1;

 U1IP0_bit = 0;
 U1IP1_bit = 1;
 U1IP2_bit = 1;
 U1IS1_bit = 1;
 U1IS0_bit = 1;

 URXISEL0_bit = 0;
 URXISEL1_bit = 0;

 U1RXIF_bit = 0;
 U1RXIE_bit = 1;
}
#line 103 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_StartTx(void) {
 UTXEN_bit = 1;

 UTXISEL0_bit = 0;
 UTXISEL1_bit = 1;

 U1TXIF_bit = 0;
 U1TXIE_bit = 1;
}
#line 120 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void InitUART1(void) {
 UART1_SetBaud();
 UART1_RxQueueInit();
 UART1_TxQueueInit();
 UART1_StartRx();
}
#line 129 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_TxQueueInit(void) {
 TxQ.TxIn = 0;
 TxQ.TxOut = 0;
 XmtBufPtr = 0;
}
#line 137 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_RxQueueInit(void) {
 RxQ.RxIn = 0;
 RxQ.RxOut = 0;
 RcvBufPtr = 0;
}
#line 145 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_SendMsg(char *s) {
 XmtBuf = s;
 XmtBufPtr = 0;
 UART1_StartTx();
}
#line 156 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_CheckQueue(void) {


 if ((!U1TXIE_bit)&&(TRMT_bit)) {

 if (TxQ.TxIn != TxQ.TxOut) {
 UART1_SendMsg(TxQ.TxQueue[TxQ.TxOut++]);
 if (TxQ.TxOut > ( 32 -1))
 TxQ.TxOut = 0;
 } else {
 UART_Busy =  0 ;
 }
 }
}
#line 174 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_PutQueue(char *msg) {
 TxQ.TxQueue[TxQ.TxIn++] = msg;
 if (TxQ.TxIn > ( 32 -1))
 TxQ.TxIn = 0;

 UART_Busy =  1 ;
}
#line 186 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
char UART1_GetChar(char *rxbyte) {
 if (RxQ.RxIn != RxQ.RxOut){
 *rxbyte = RxQ.RxQueue[RxQ.RxOut++];
 if (RxQ.RxOut > ( 64 -1))
 RxQ.RxOut = 0;
 return 1;
 } else {
 return 0;
 }
}
#line 199 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx(void) {
 UART1_RxFuncPtr();
}
#line 206 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx1(void) {
 char rxchar;

 if (UART1_GetChar(&rxchar)) {
 switch (rxchar){
 case  0x00 :
 break;

 case '\r':
 break;

 case '\n':
 RcvBuf[RcvBufPtr++] = rxchar;
 RcvBuf[RcvBufPtr] = 0;
 RcvBufPtr = 0;
 UART1_RxFuncPtr = UART1_Rx2;
 break;

 default:
 if (RcvBufPtr < ( 64 -2))
 RcvBuf[RcvBufPtr++] = rxchar;
 break;
 }
 }
}
#line 234 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx2(void) {
 char *BufNum;

 switch (RcvBuf[0]) {



 case 'a':
 UART1_PutQueue("ACK\r\n");
 break;

 case 'b':
 break;

 case 'c':
 break;

 case 'd':
 break;

 case 'e':
 break;

 case 'f':
 break;

 case 'g':
 break;

 case 'h':
 break;

 case 'i':
 break;

 case 'j':
 break;

 case 'k':
 break;

 case 'l':
 break;

 case 'm':
 break;

 case 'n':
 break;

 case 'o':
 break;

 case 'p':
 break;

 case 'q':
 break;

 case 'r':
 break;

 case 's':
 break;

 case 't':
 break;

 case 'u':
 break;

 case 'v':
 break;

 case 'w':
 if (OpenFile("Test1.txt")) {

 while (ReadFile(FileDataBfr) == 0) {
 UART1_PutQueue(FileDataBfr);

 while (UART_Busy ==  1 ) {
 UART1_CheckQueue();
 }
 }

 CloseFile();
 }
 break;

 case 'x':
 break;

 case 'y':
 Counter1 = 0;
 memset(FileDataBfr,0,512);
 Mmc_Fat_Dir(PrintChar);
 strcat(FileDataBfr,"\r\n");
 UART1_PutQueue(FileDataBfr);
 break;








 default:
 UART1_PutQueue("Unknown command: ");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
 UART1_PutQueue(BufNum);
 break;
 }
 UART1_RxFuncPtr = UART1_Rx1;
}

void PrintChar(char Ch) {
 FileDataBfr[Counter1++] = Ch;
}
