_InitMMC:
;MMC_Driver.c,51 :: 		void InitMMC() {
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;MMC_Driver.c,55 :: 		SPI1_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 64, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R28, 16(SP)
ORI	R2, R0, 64
MOVZ	R28, R0, R0
ORI	R27, R0, 64
MOVZ	R26, R0, R0
ORI	R25, R0, 32
ADDIU	SP, SP, -8
SH	R0, 4(SP)
SH	R2, 2(SP)
SH	R0, 0(SP)
JAL	_SPI1_Init_Advanced+0
NOP	
ADDIU	SP, SP, 8
;MMC_Driver.c,56 :: 		Delay_ms(10);
LUI	R24, 4
ORI	R24, R24, 4522
L_InitMMC0:
ADDIU	R24, R24, -1
BNE	R24, R0, L_InitMMC0
NOP	
;MMC_Driver.c,59 :: 		CardStatus = Mmc_Fat_Init();
JAL	_Mmc_Fat_Init+0
NOP	
; CardStatus start address is: 12 (R3)
ANDI	R3, R2, 255
;MMC_Driver.c,61 :: 		if (CardStatus > 0) {
ANDI	R2, R3, 65535
; CardStatus end address is: 12 (R3)
SLTIU	R2, R2, 1
BEQ	R2, R0, L__InitMMC23
NOP	
J	L_InitMMC2
NOP	
L__InitMMC23:
;MMC_Driver.c,62 :: 		CardOK = FALSE;
SB	R0, Offset(_CardOK+0)(GP)
;MMC_Driver.c,63 :: 		DEBUGOUT("SD card missing\r\n");
LUI	R25, #hi_addr(?lstr1_MMC_Driver+0)
ORI	R25, R25, #lo_addr(?lstr1_MMC_Driver+0)
JAL	_UART1_PutQueue+0
NOP	
;MMC_Driver.c,64 :: 		} else {
J	L_InitMMC3
NOP	
L_InitMMC2:
;MMC_Driver.c,66 :: 		SPI1_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 8, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);
ORI	R2, R0, 64
MOVZ	R28, R0, R0
ORI	R27, R0, 8
MOVZ	R26, R0, R0
ORI	R25, R0, 32
ADDIU	SP, SP, -8
SH	R0, 4(SP)
SH	R2, 2(SP)
SH	R0, 0(SP)
JAL	_SPI1_Init_Advanced+0
NOP	
ADDIU	SP, SP, 8
;MMC_Driver.c,67 :: 		CardOK = TRUE;
ORI	R2, R0, 1
SB	R2, Offset(_CardOK+0)(GP)
;MMC_Driver.c,68 :: 		DEBUGOUT("SPI set to high speed\r\n");
LUI	R25, #hi_addr(?lstr2_MMC_Driver+0)
ORI	R25, R25, #lo_addr(?lstr2_MMC_Driver+0)
JAL	_UART1_PutQueue+0
NOP	
;MMC_Driver.c,69 :: 		}
L_InitMMC3:
;MMC_Driver.c,70 :: 		DEBUGOUT("SPI initialized\r\n");
LUI	R25, #hi_addr(?lstr3_MMC_Driver+0)
ORI	R25, R25, #lo_addr(?lstr3_MMC_Driver+0)
JAL	_UART1_PutQueue+0
NOP	
;MMC_Driver.c,71 :: 		}
L_end_InitMMC:
LW	R28, 16(SP)
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _InitMMC
_CreateFile:
;MMC_Driver.c,79 :: 		char CreateFile(char *filename) {
ADDIU	SP, SP, -56
SW	RA, 0(SP)
;MMC_Driver.c,84 :: 		if (CardOK == TRUE) {
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R28, 16(SP)
LBU	R3, Offset(_CardOK+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__CreateFile25
NOP	
J	L_CreateFile4
NOP	
L__CreateFile25:
;MMC_Driver.c,86 :: 		Month = ts1.mo;
; Month start address is: 20 (R5)
LBU	R5, Offset(_ts1+5)(GP)
;MMC_Driver.c,87 :: 		Day = ts1.md;
; Day start address is: 24 (R6)
LBU	R6, Offset(_ts1+3)(GP)
;MMC_Driver.c,88 :: 		Hour = ts1.hh;
; Hour start address is: 28 (R7)
LBU	R7, Offset(_ts1+2)(GP)
;MMC_Driver.c,89 :: 		Minute = ts1.mn;
; Minute start address is: 32 (R8)
LBU	R8, Offset(_ts1+1)(GP)
;MMC_Driver.c,90 :: 		Second = ts1.ss;
; Second start address is: 36 (R9)
LBU	R9, Offset(_ts1+0)(GP)
;MMC_Driver.c,92 :: 		sprintf(TDString,"%04d/%02d/%02d %02d:%02d:%02d",ts1.yy,Month,Day,Hour,Minute,Second);
ADDIU	R4, SP, 24
LHU	R3, Offset(_ts1+6)(GP)
LUI	R2, #hi_addr(?lstr_4_MMC_Driver+0)
ORI	R2, R2, #lo_addr(?lstr_4_MMC_Driver+0)
SW	R25, 20(SP)
; Second end address is: 36 (R9)
ADDIU	SP, SP, -32
SH	R9, 28(SP)
SH	R8, 24(SP)
; Minute end address is: 32 (R8)
SH	R7, 20(SP)
; Hour end address is: 28 (R7)
SH	R6, 16(SP)
; Day end address is: 24 (R6)
SH	R5, 12(SP)
; Month end address is: 20 (R5)
SH	R3, 8(SP)
SW	R2, 4(SP)
SW	R4, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 32
LW	R25, 20(SP)
;MMC_Driver.c,94 :: 		if (Mmc_Fat_Exists(filename)) {     // Find existing file or create a new one
SW	R25, 20(SP)
JAL	_Mmc_Fat_Exists+0
NOP	
LW	R25, 20(SP)
BNE	R2, R0, L__CreateFile27
NOP	
J	L_CreateFile5
NOP	
L__CreateFile27:
;MMC_Driver.c,96 :: 		Mmc_Fat_Assign(filename, 0);
MOVZ	R26, R0, R0
JAL	_Mmc_Fat_Assign+0
NOP	
;MMC_Driver.c,97 :: 		Mmc_Fat_Append();
JAL	_Mmc_Fat_Append+0
NOP	
;MMC_Driver.c,98 :: 		return 1;
ORI	R2, R0, 1
J	L_end_CreateFile
NOP	
;MMC_Driver.c,100 :: 		} else {
L_CreateFile5:
;MMC_Driver.c,102 :: 		Mmc_Fat_Assign(filename, 0xA0);
ORI	R26, R0, 160
JAL	_Mmc_Fat_Assign+0
NOP	
;MMC_Driver.c,103 :: 		Mmc_Fat_Set_File_Date(ts1.yy,ts1.mo,ts1.md,ts1.hh,ts1.mn,ts1.ss); // Set file date & time info
LBU	R3, Offset(_ts1+0)(GP)
LBU	R2, Offset(_ts1+1)(GP)
LBU	R28, Offset(_ts1+2)(GP)
LBU	R27, Offset(_ts1+3)(GP)
LBU	R26, Offset(_ts1+5)(GP)
LHU	R25, Offset(_ts1+6)(GP)
ADDIU	SP, SP, -4
SB	R3, 1(SP)
SB	R2, 0(SP)
JAL	_Mmc_Fat_Set_File_Date+0
NOP	
ADDIU	SP, SP, 4
;MMC_Driver.c,104 :: 		Mmc_Fat_Rewrite();
JAL	_Mmc_Fat_Rewrite+0
NOP	
;MMC_Driver.c,105 :: 		return 2;
ORI	R2, R0, 2
J	L_end_CreateFile
NOP	
;MMC_Driver.c,108 :: 		} else {
L_CreateFile4:
;MMC_Driver.c,109 :: 		return 0;
MOVZ	R2, R0, R0
;MMC_Driver.c,111 :: 		}
;MMC_Driver.c,109 :: 		return 0;
;MMC_Driver.c,111 :: 		}
L_end_CreateFile:
LW	R28, 16(SP)
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 56
JR	RA
NOP	
; end of _CreateFile
_WriteFile:
;MMC_Driver.c,119 :: 		char WriteFile(char *buf) {
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;MMC_Driver.c,120 :: 		if (CardOK == TRUE) {
SW	R26, 4(SP)
LBU	R3, Offset(_CardOK+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__WriteFile29
NOP	
J	L_WriteFile8
NOP	
L__WriteFile29:
;MMC_Driver.c,121 :: 		Mmc_Fat_Write(buf,strlen(buf));
JAL	_strlen+0
NOP	
SEH	R26, R2
JAL	_Mmc_Fat_Write+0
NOP	
;MMC_Driver.c,122 :: 		return 1;
ORI	R2, R0, 1
J	L_end_WriteFile
NOP	
;MMC_Driver.c,123 :: 		} else {
L_WriteFile8:
;MMC_Driver.c,124 :: 		return 0;
MOVZ	R2, R0, R0
;MMC_Driver.c,126 :: 		}
;MMC_Driver.c,124 :: 		return 0;
;MMC_Driver.c,126 :: 		}
L_end_WriteFile:
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _WriteFile
_CloseFile:
;MMC_Driver.c,134 :: 		char CloseFile(void) {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;MMC_Driver.c,135 :: 		if (Mmc_Fat_Close() == 0) {
JAL	_Mmc_Fat_Close+0
NOP	
ANDI	R2, R2, 255
BEQ	R2, R0, L__CloseFile31
NOP	
J	L_CloseFile10
NOP	
L__CloseFile31:
;MMC_Driver.c,136 :: 		return 1;
ORI	R2, R0, 1
J	L_end_CloseFile
NOP	
;MMC_Driver.c,137 :: 		} else {
L_CloseFile10:
;MMC_Driver.c,138 :: 		return 0;
MOVZ	R2, R0, R0
;MMC_Driver.c,140 :: 		}
L_end_CloseFile:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _CloseFile
_OpenFile:
;MMC_Driver.c,147 :: 		short OpenFile(char *filename) {
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;MMC_Driver.c,148 :: 		if (CardOK == TRUE) {
SW	R26, 4(SP)
SW	R27, 8(SP)
LBU	R3, Offset(_CardOK+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__OpenFile33
NOP	
J	L_OpenFile12
NOP	
L__OpenFile33:
;MMC_Driver.c,149 :: 		Mmc_Fat_Open(filename, FILE_READ, 0x01);
ORI	R27, R0, 1
ORI	R26, R0, 1
JAL	_Mmc_Fat_Open+0
NOP	
;MMC_Driver.c,150 :: 		return 1;
ORI	R2, R0, 1
J	L_end_OpenFile
NOP	
;MMC_Driver.c,151 :: 		} else {
L_OpenFile12:
;MMC_Driver.c,152 :: 		return 0;
MOVZ	R2, R0, R0
;MMC_Driver.c,154 :: 		}
;MMC_Driver.c,152 :: 		return 0;
;MMC_Driver.c,154 :: 		}
L_end_OpenFile:
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _OpenFile
_ReadFile:
;MMC_Driver.c,164 :: 		int ReadFile(char *buf) {
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;MMC_Driver.c,169 :: 		status = Mmc_Fat_EOF();
SW	R26, 4(SP)
SW	R27, 8(SP)
JAL	_Mmc_Fat_EOF+0
NOP	
SEB	R2, R2
SH	R2, 20(SP)
;MMC_Driver.c,171 :: 		if (status == 0) {
LH	R2, 20(SP)
BEQ	R2, R0, L__ReadFile35
NOP	
J	L_ReadFile14
NOP	
L__ReadFile35:
;MMC_Driver.c,172 :: 		memset(buf,0,128);  // Clear the buffer
ORI	R27, R0, 128
MOVZ	R26, R0, R0
JAL	_memset+0
NOP	
;MMC_Driver.c,173 :: 		Count = 0;
; Count start address is: 16 (R4)
MOVZ	R4, R0, R0
;MMC_Driver.c,174 :: 		Ch = 0;
SB	R0, 22(SP)
; Count end address is: 16 (R4)
;MMC_Driver.c,176 :: 		while ((Ch != '\n') && (Count < 127)) {
L_ReadFile15:
; Count start address is: 16 (R4)
LBU	R3, 22(SP)
ORI	R2, R0, 10
BNE	R3, R2, L__ReadFile37
NOP	
J	L__ReadFile21
NOP	
L__ReadFile37:
SEH	R2, R4
SLTI	R2, R2, 127
BNE	R2, R0, L__ReadFile38
NOP	
J	L__ReadFile20
NOP	
L__ReadFile38:
L__ReadFile19:
;MMC_Driver.c,177 :: 		Mmc_Fat_Read(&Ch);
ADDIU	R2, SP, 22
SH	R4, 12(SP)
SW	R25, 16(SP)
MOVZ	R25, R2, R0
JAL	_Mmc_Fat_Read+0
NOP	
LW	R25, 16(SP)
LH	R4, 12(SP)
;MMC_Driver.c,178 :: 		buf[Count++] = Ch;
SEH	R2, R4
ADDU	R3, R25, R2
LBU	R2, 22(SP)
SB	R2, 0(R3)
ADDIU	R2, R4, 1
; Count end address is: 16 (R4)
; Count start address is: 8 (R2)
;MMC_Driver.c,179 :: 		}
SEH	R4, R2
; Count end address is: 8 (R2)
J	L_ReadFile15
NOP	
;MMC_Driver.c,176 :: 		while ((Ch != '\n') && (Count < 127)) {
L__ReadFile21:
L__ReadFile20:
;MMC_Driver.c,180 :: 		}
L_ReadFile14:
;MMC_Driver.c,181 :: 		return (status);
LH	R2, 20(SP)
;MMC_Driver.c,182 :: 		}
;MMC_Driver.c,181 :: 		return (status);
;MMC_Driver.c,182 :: 		}
L_end_ReadFile:
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _ReadFile
