#line 1 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MmcTest_main.c"
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/mmctest_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
};

extern TScreen Screen1;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel * const code Screen1_Labels[2];









extern char Label1_Caption[];
extern char Label2_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void Check_TP();
void Start_TP();
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/uart1.h"
#line 29 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/uart1.h"
typedef void (*tPointerFcn)(void);
typedef char *pnt;


 typedef struct rx_q_struct
 {
 int RxIn;
 int RxOut;
 char RxQueue[ 64 ];
 } rx_q_struct;


typedef struct tx_q_struct
{
 int TxIn;
 int TxOut;
 pnt TxQueue[ 32 ];
} tx_q_struct;




void UART1_SetBaud(void);
void UART1_StartRx(void);
void UART1_StartTx(void);

void InitUART1(void);
void UART1_TxQueueInit(void);
void UART1_RxQueueInit(void);

void UART1_SendMsg(char *s);
void UART1_CheckQueue(void);
void UART1_PutQueue(char *msg);
char UART1_GetChar(char *rxbyte);


void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void PrintChar(char Ch);
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/coretimer.h"
#line 13 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/coretimer.h"
void InitCoreTimer(void);
void TimerCheck();
#line 1 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/mmc_driver.h"
#line 14 "c:/users/public/projects/pic/projects/testmmc/mmctest_code/mikroc pro for pic32/mmc_driver.h"
void InitMMC();

char CreateFile(char *FileName);
char WriteFile(char *buf);
char CloseFile(void);
short OpenFile(char *filename);
int ReadFile(char *buf);
#line 27 "C:/Users/Public/Projects/PIC/Projects/TestMmc/MmcTest_Code/mikroC PRO for PIC32/MmcTest_main.c"
void main() {

 Start_TP();

 InitUART1();
 UART1_PutQueue("MMC Test Started\r\n");
 EnableInterrupts();

 InitMMC();

 while (1) {
 Check_TP();
 TimerCheck();
 UART1_CheckQueue();
 UART1_Rx();

 }

}
